#lang racket/base
(require (for-syntax racket/base)
         racket/math
         racket/flonum)

(provide (struct-out td)
         test-data)

(struct td (data line))

(define-syntax (a-td stx)
  (syntax-case stx ()
    [(_ arg)
     (with-syntax ([line (syntax-line stx)])
       #'(td arg line))]))

(define test-data
  (list (a-td (list 0.0+0.0i))
        (a-td (list 0.0+1.0i))
        (a-td (list 1.0+0.0i))
        (a-td (list 0.0+0.0i 0.0+0.0i))
        (a-td (list 0.0+0.0i 1.0+0.0i))
        (a-td (list 0.0+0.0i 0.0+1.0i))
        (a-td (for/list ([t 64]) 1.0+1.0i))
        (a-td (for/list ([t 1024]) 
                (define in (* t (/ (* 2 pi) 500)))
                (+ (flsin (if (= in 0) 0.0 in))
                   0+1i)))
        (a-td (for/list ([t 1024]) 
                (define in (* t (/ (* 2 pi) 500)))
                (make-rectangular
                 (flsin (if (= in 0) 0.0 in))
                 (flcos (if (= in 0) 0.0 in)))))
        (a-td (for/list ([t 512]) ;; with 1024 we run out of floats
                (define in (* (+ t 1) 1.0))
                (make-rectangular
                 (flexpt 2.0 in)
                 (fllog in))))))
