#lang racket/base
;; fft1
;; parallel (unrestricted splitting), list-based, untyped

(provide fft1)

(require (only-in racket/math pi)
         racket/future
         "fft0.rkt")

;; START fft1
(define (fft1 as)
  (cond 
    [(= (length as) 1) as]
    [else
     (define-values (ss ts)
       (decimate-in-time as))
     (define bs 
       (future 
        (λ () (fft1 ss))))
     (define cs
       (future
        (λ () (twiddle-factor (fft1 ts)))))
     (append 
      (for/list ([b (in-list (touch bs))]
                 [c (in-list (touch cs))])
        (+ b c))
      (for/list ([b (in-list (touch bs))]
                 [c (in-list (touch cs))])
        (- b c)))]))
;; STOP fft1

(provide run-fft1)
(define (run-fft1 l)
  (collect-garbage) (collect-garbage) (collect-garbage)
  (collect-garbage) (collect-garbage) (collect-garbage)
  (time-apply fft1 (list l)))

(module+ main
  (require racket/list)
  (define res
    (fft1 (for/list ([t 1024]) (sin (* t (/ (* 2 pi) 500))))))

  (define to-plot
    (for/list ([r res]
               [i (in-naturals)])
      (vector i (real-part r))))

  (require plot)
  (plot-new-window? #t)
  (plot (points to-plot))
  (read-line))
